



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>使用XStream是实现XML与Java对象的转换(1)--简介及入门示例</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">使用XStream是实现XML与Java对象的转换(1)--简介及入门示例</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 02:16:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、简单介绍</h2>
<p>XStream是thoughtworks开发的开源框架，用于实现XML数据于Java对象、Json数据的转换。它不需要schema或其他的mapping文件就可以进行java对象和xml文件之间的转换，API调用起来非常方便，并且扩展功能强大。</p>
<p><strong>1</strong><strong>，</strong><strong>XStream</strong><strong>的特点</strong></p>
<p>a)灵活易用：在更高的层次上提供了简单、灵活、易用的统一接口，用户无需了解项目的底层细节</p>
<p>b)无需映射：大多数对象都可以在无需映射的情况下进行序列化与反序列化的操作</p>
<p>c)高速稳定：设计时力求达到的最重要的指标是解析速度快、占用内存少，以使之能够适用于大的对象处理或是对信息吞吐量要求高的系统</p>
<p>d)清晰易懂：项目采用reflection机制得到无冗余信息的XML文件。所生成的XML文件较本地Java序列化产物更简洁，格式更清晰，更便于用户阅读</p>
<p>e)无需修改：<strong>完全序列化包括</strong><strong>private</strong><strong>和final</strong><strong>类型在内的全部内部字段。支持非公有类和内部类，类可以没有缺省的构造函数。</strong></p>
<p>f)易于集成：通过实现特定的接口，XStream可以直接与其它任何树型结构进行序列化与反序列化操作（而不仅仅是XML格式）</p>
<p>g)灵活转换：转换策略是可以定制的，允许用户自定义特殊类型的对象如何以XML格式存储。</p>
<p>h)错误处理：由于XML文本不合法而造成异常时，会提供详细地诊断信息帮助处理问题。</p>
<p><strong>2</strong><strong>，应用场合</strong></p>
<p>a)数据对象的持久化</p>
<p>b)数据交换</p>
<p>c)配置文件</p>
<p><strong>3</strong><strong>，架构分析</strong></p>
<p>a)Converters（转换器）</p>
<p>当XStream遇到需要转换的对象时，它会委派给合适的转换器实现，XStream为通用类型提供了多种转换器实现，包括基本数据类型、String、Collections、Arrays、null、Date，等等。</p>
<p>XStream提供了缺省的转换器，当需要转换的数据对象没有匹配的转换器时会使用。是通过反射机制自动完成对对象内所有字段的映射。</p>
<p>b)IO（输入/输出）</p>
<p>XStream是通过接口HierarchicalStramWriter和HierarchialStreamReader从底层XML数据中抽象而来的，上面的接口分别用于序列化和反序列化操作。</p>
<p>该特性使得XStream可以直接使用XML解析类从数据流中读取数据，或者是直接从已经存在的结构中提取数据（比如DOM）。如果XStream所操作的&nbsp;XML数据已经部分被其它XML解析类处理过了（比如SOAP类的实例），这样就可以避免在我们这一层的再次解析操作。</p>
<p>c)Context（上下文引用）</p>
<p>在XStream序列化或反序列化对象时，它会创建两个类MarshallingContext和UnmarshallingContext，由它们来处理数据，以及委派合适的转换器。</p>
<p>XStream提供了三对上下文的缺省实现，它们之间有着细微的差别。缺省值可以通过方法XStream.setMode()来改变，需要传递下面参数中的一个：</p>
<p>i)XStream.XPATH_REFERENCES，(缺省的)通过XPath引用来标识重复的引用。这样产生的XML具有最小的混乱性。</p>
<p>ii)XStream.ID_REFERENCES，使用ID引用来标识重复的引用。在一些场合，比如使用手写XML时，这样将会更易于操作</p>
<p>iii)XStream.NO_REFERENCES，这种情况将失去对图形对象的支持，仅把对象看作为树型结构。重复的引用被视作两个不同的对象，循环引用会导致异常产生。相对于上面两种模式，这种模式速度会更快，占用内存会更</p>
<p>d)Facade（统一入口）</p>
<p>主要类XStream用作所有项目的入口点。它将上面所提及的重要组件集成在一起，提供更简单易用的API操作。</p>
<h2>二、资源网址</h2>
<p>项目主页：</p>
<p><a href="http://xstream.codehaus.org/" rel="external nofollow noreferrer">http://xstream.codehaus.org/</a></p>
<p>在线帮助文档：<a href="http://xstream.codehaus.org/javadoc/index.html" rel="external nofollow noreferrer">http://xstream.codehaus.org/javadoc/index.html</a></p>
<p>lib和源码下载：<a href="http://xstream.codehaus.org/download.html" rel="external nofollow noreferrer">http://xstream.codehaus.org/download.html</a></p>
<h2>三、注意事项：</h2>
<p><strong>1</strong><strong>，XStream</strong><strong>将Java</strong><strong>对象序列化为XML</strong><strong>数据时，不关心属性字段是否是final</strong><strong>、private</strong><strong>类型，也不关心是否有对应的get/set</strong><strong>方法，更不关心你是否有一个默认的无参构造方法。</strong></p>
<p><strong>2</strong><strong>，项目的classpath</strong><strong>中应该有3</strong><strong>个包</strong>：xstream-[版本].jar，xpp3-[版本].jar，xmlpull-[版本].jar。</p>
<h2>四、使用入门示例及介绍</h2>
<p><strong>1</strong><strong>，示例代码</strong></p>
<div>
<ol><li>import&nbsp;com.thoughtworks.xstream.XStream;</li>
<li>import&nbsp;com.thoughtworks.xstream.io.xml.DomDriver;</li>
<li>import&nbsp;com.thoughtworks.xstream.io.xml.StaxDriver;</li>
<li>public&nbsp;class&nbsp;XStreamTest&nbsp;{</li>
<li>public&nbsp;static&nbsp;void&nbsp;main(String[]&nbsp;args)&nbsp;{</li>
<li>Person&nbsp;p&nbsp;=&nbsp;new&nbsp;Person();</li>
<li>p.sex&nbsp;=&nbsp;new&nbsp;StringBuffer("未知");</li>
<li>p.set("如花");</li>
<li>p.age&nbsp;=&nbsp;70;</li>
<li>System.out.println("转换之前的Person对象p="+p);</li>
<li>//这样创建XStream实例时，上面那3个jar包必须都有</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;XStream&nbsp;xstream&nbsp;=&nbsp;new&nbsp;XStream();</li>
<li>//这里不需要XPP3库了，而是使用标准的JAXP&nbsp;DOM解析XML</li>
<li>//&nbsp;&nbsp;&nbsp;&nbsp;XStream&nbsp;xstream&nbsp;=&nbsp;new&nbsp;XStream(new&nbsp;DomDriver());</li>
<li>//这里不需要XPP3库了但是需要你使用java&nbsp;6</li>
<li>XStream&nbsp;xstream&nbsp;=&nbsp;new&nbsp;XStream(new&nbsp;StaxDriver());</li>
<li>String&nbsp;xml&nbsp;=&nbsp;xstream.toXML(p);</li>
<li>System.out.println("转换生成XML字符串=="+xml);</li>
<li>Person&nbsp;p2&nbsp;=&nbsp;(Person)&nbsp;xstream.fromXML(xml);</li>
<li>System.out.println("转换之后的Person对象p2="+p2);</li>
<li>}</li>
<li>}</li>
<li>class&nbsp;Person{</li>
<li>private&nbsp;String&nbsp;name;</li>
<li>int&nbsp;age;</li>
<li>public&nbsp;StringBuffer&nbsp;sex;</li>
<li>public&nbsp;void&nbsp;set(String&nbsp;name){</li>
<li>this.name&nbsp;=&nbsp;name;</li>
<li>}</li>
<li>public&nbsp;String&nbsp;toString(){</li>
<li>return&nbsp;"{name="+name+";age="+age+";sex="+sex+"}";</li>
<li>}</li>
<li>}</li></ol>
</div>
<p>运行结果：</p>
<p>转换之前的Person对象p={name=如花;age=70;sex=未知}</p>
<p>转换生成XML字符串==&lt;?xml version="1.0" ?&gt;&lt;cn.tjpu.zhw.xml.Person&gt;&lt;name&gt;如花&lt;/name&gt;&lt;age&gt;70&lt;/age&gt;&lt;sex&gt;未知&lt;/sex&gt;&lt;/cn.tjpu.zhw.xml.Person&gt;</p>
<p>转换之后的Person对象p2={name=如花;age=70;sex=未知}</p>
<p><strong>2</strong><strong>，创建XStream对象</strong></p>
<p><strong>a</strong>)无参构造函数，默认使用XPP3包</p>
<div>
<ol><li>//这样创建XStream实例时，上面那3个jar包必须都有</li>
<li>XStream&nbsp;xstream&nbsp;=&nbsp;new&nbsp;XStream();</li></ol>
</div>
<p><strong>b</strong>)有参构造函数，使用标准的JAXP DOM</p>
<div>
<ol><li>//这里不需要XPP3和xmlpull库了，而是使用标准的JAXP&nbsp;DOM解析XML</li>
<li>XStream&nbsp;xstream&nbsp;=&nbsp;new&nbsp;XStream(new&nbsp;DomDriver());</li></ol>
</div>
<p><strong>c</strong>)有参构造函数，使用StAX解析XML</p>
<div>
<ol><li>//这里不需要XPP3库了但是需要你使用java&nbsp;6</li>
<li>XStream&nbsp;xstream&nbsp;=&nbsp;new&nbsp;XStream(new&nbsp;StaxDriver());</li></ol>
</div>
<p><strong>3</strong><strong>，将Java对象转换成为XML字符串</strong></p>
<p>String xml = xstream.toXML(p);</p>
<p>结果是：</p>
<div>
<ol><li>&lt;?xml&nbsp;version="1.0"&nbsp;?&gt;</li>
<li>&lt;cn.tjpu.zhw.xml.Person&gt;</li>
<li>&lt;name&gt;如花&lt;/name&gt;</li>
<li>&lt;age&gt;70&lt;/age&gt;</li>
<li>&lt;sex&gt;未知&lt;/sex&gt;</li>
<li>&lt;/cn.tjpu.zhw.xml.Person&gt;</li></ol>
</div>
<p><strong>4</strong><strong>，将XML转换成为Java对象</strong></p>
<p>Person p2 = (Person) xstream.fromXML(xml);</p>
<p>参考文章：<a href="http://www.doc88.com/p-091909836812.html" rel="external nofollow noreferrer">http://www.doc88.com/p-091909836812.html</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93m0n83.html">C&num;开发微信门户及应用&lpar;10&rpar;--在管理系统中同步微信用户分组信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z1xk19.html">常用的shell脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gjp5z9.html">ABP理论学习之Web API控制器（新增）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9671g48.html">Win10 Hyper-V 配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy5v2x9.html">WCF XmlSerializer GetType 反射类型 报错 解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/r930z5n9.html">Android --ListView分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw717l8.html">Fiddler 的Window 8&period;1中不可以正常工作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1p7n69.html">【JZOI2002】【BZOJ1477】【P1371】青蛙的约会</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zv2p29.html">实战Django：官方实例Part4</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmp7p79.html">linux CentOS 系统下如何将php和mysql命令加入到环境变量中</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjkpkz9.html">嵌入式 Linux进程含义知多少</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ym1k0q.html">C&num;用串口接收事件接不全数据的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1wr2z9.html">注意 sizeof 中不要有复杂运算操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pjgnn8.html">多线程之Future模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j5rgv8.html">grub 的安装与使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z1pzn9.html">Git与Github的基本概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pxpdn8.html">Java 8中用法优雅的Stream，性能也&amp;quot&semi;优雅&amp;quot&semi;吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j102we9.html">MATLAB实现二值化函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv22nlz9.html">【shiro】&lpar;4&rpar;---Shiro认证、授权案例讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw65ok8.html">Tumblr 架构设计</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rgl2578.html">iOS下JS与OC互相调用（三）--MessageHandler</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy13zg2q.html">Socket接收器&mdash;&mdash;Acceptor</a>
			</li>
						<li><a href="https://www.batexi.com/a/95012k68.html">ROS&lpar;indigo&rpar;使用Qt Creator Plug in即ros&lowbar;qtc&lowbar;plugin</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pnx4v8.html">&lpar;NO&period;00004&rpar;iOS实现打砖块游戏&lpar;四&rpar;&colon;砖块类的实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eykn2k9.html">Cocos2D将v1&period;0的tileMap游戏转换到v3&period;4中一例&lpar;八&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkgp7d8.html">FreeMarker生成word的代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geylg48.html">java中public与private还有protect的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z1p0g9.html">打包自己的aar库</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jldrv8.html">android studio中使用lambda</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pwo7y8.html">Volley请求</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
